# -*- coding: utf-8 -*-

def getText(nodelist):
    rc = []
    for node in nodelist:
        if node.nodeType == node.TEXT_NODE:
           rc.append(node.data)
    return ''.join(rc)

import os
import shutil
import zipfile
import xml.dom.minidom
import urllib

"""
UPDATE_FILE = "http://www.team-mediaportal.com/index.php?option=com_mtree&task=att_download&link_id=202&cf_id=52"
urllib.urlretrieve(UPDATE_FILE, "update.xml")
dom = xml.dom.minidom.parse("update.xml")
download_url = getText(dom.getElementsByTagName("OnlineLocation")[0].childNodes)
print download_url.split('/')[-1]
"""

CHANNELNAMES_WRONG = ["orf3", "ServusTV", "Servus TV HD", "Fashion TV", "EinsFestival HD",
"EinsFestival", "Das Vierte", "sixx", "orfsportplus", "Al Jazeera", "Al Jazeera International",
"sportdigital.tv", "MTV Music", "hustler", "Bloomberg", "Phoenix HD", "Anixe HD", "Anixe SD",
"Sport1", "MTV DANCE", "MTV HITS", "puls 4 Austria", "Phoenix", "KiKa", "Super RTL A", "Deluxe Music",
"ZDF_neo", "Zdfinfo", u"BR SÜD HD"]
CHANNELNAMES_CORRECT = ["ORF III", "ServusTV Oesterreich", "ServusTV HD Oesterreich", "FASHION ONE", "Einsfestival HD",
"Einsfestival", "DAS VIERTE", "sixx Austria", "ORF SPORT +", "Al Jazeera Channel", "Al Jazeera English",
"sportdigital", "MTV Music 24", "Hustler TV", "Bloomberg Europe TV", "PHOENIX HD", "ANIXE HD", "ANIXE SD",
"SPORT1", "MTV Dance", "MTV Hits", "PULS 4 Austria", "PHOENIX", "KiKA", "SUPER RTL A", "DELUXE MUSIC",
"zdf_neo", "ZDFinfo", u"BR Süd HD"]

z = zipfile.ZipFile("Deutsches Logo Pack (MP 1.2)_v1.1.0.0.mpe1")
z.extractall("./temp")
z.close()

dom = xml.dom.minidom.parse("./temp/MediaPortalExtension.xml")
groups = dom.getElementsByTagName("GroupItem")
for i, group in enumerate(groups):
    dn = "./logos/" + getText(group.getElementsByTagName("DisplayName")[0].childNodes).replace("/", "-") + "/logos/"
    logos = group.getElementsByTagName("FileItem")
    for logo in logos:
        title = logo.getElementsByTagName("ZipFileName")[0]
        title2 = logo.getElementsByTagName("DestinationFilename")[0]
        from_temp = getText(title.childNodes)
        to_temp = getText(title2.childNodes)
        to_index = to_temp.find("\\")
    
        from_ = "./temp/" + from_temp.replace("\\", "/")
        to_ = "./" + str(i) + "/" + to_temp[to_index+1:].replace("\\", "/")
        filename_ = os.path.split(to_)[1]
    
        if not os.path.isdir(dn):
            os.makedirs(dn)
          
        os.rename(from_, dn + "/" + filename_)
        
        if os.path.splitext(filename_)[0] in CHANNELNAMES_WRONG:
            
            index_filename = CHANNELNAMES_WRONG.index(os.path.splitext(filename_)[0])
            filename_new = CHANNELNAMES_CORRECT[index_filename]
        
            shutil.copy(dn + "/" + filename_, dn + "/" + filename_new + ".png")

#os.remove("./temp/MediaPortalExtension.xml")
#os.rmdir("./temp/Installer{CopyFile}")
